using Serilog;
using SlnMesnac.Common;
using SlnMesnac.Model.dto;
using SlnMesnac.Rfid.Dto;
using SlnMesnac.Rfid.Enum;
using SlnMesnac.Rfid.NewRFIDConnect;
using SlnMesnac.Rfid.NewRFIDConnect.entity;
using SlnMesnac.Serilog;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TouchSocket.Core;
using TouchSocket.Sockets;
using static System.Collections.Specialized.BitVector32;

namespace SlnMesnac.Rfid.Factory
{
    public class FuchsFactory : RfidAbsractFactory
    {
        private SerilogHelper _logger;
        private readonly TcpClient _tcpClient = new TcpClient();
        private readonly StringChange _stringChange;
        private string m_strIP;
        private string m_deviceID;
        public Action<string, string> RefreshStateEvent;
        public FuchsFactory(SerilogHelper logger, StringChange stringChange)
        {
            _logger = logger;
            _stringChange = stringChange;
        }
        public override void Close()
        {
            _tcpClient.CloseAsync();
        }

        public override bool Connect(string ip, int port)
        {
            try
            {
                _tcpClient.SetupAsync(new TouchSocketConfig().SetRemoteIPHost($"{ip}:{port}"));
                _tcpClient.ConnectAsync();
                return true;
            }
            catch (Exception e)
            {
                return false;
                //throw new InvalidOperationException($"设备连接异常：{e.Message}");
            }
        }

        /// <summary>
        /// 真心跳设置
        /// </summary>
        /// <returns></returns>
        public override async Task<bool> Set_HeartBeat(byte second)
        {
            byte[] data = new byte[3];
            data[0] = 0x00;
            data[1] = second;
            data[2] = 0x01;

            BaseSendDataEntity entity = new BaseSendDataEntity()
            {
                Code = 0xBF,
                Data = data
            };

            byte[] result = BaseRFIDDataAnalyse.BaseSendDataAnalyse(entity);

            var waitClient = _tcpClient.CreateWaitingClient(new WaitingOptions()
            {
                FilterFunc = response =>
                {
                    // 检查响应数据是否符合预期
                    if (response.Memory.Length > 0)
                    {
                        // 可以根据实际情况添加更多的检查逻辑
                        return true;
                    }
                    return false;
                }
            });

            using (var responsedData = await waitClient.SendThenResponseAsync(result, 2000))
            {
                var reciveBuffer = responsedData.Memory.ToArray();

                byte[] resultBuffer = PareReceiveBufferData(reciveBuffer, reciveBuffer.Length);
                Log.Information($"{m_deviceID}接收读取指令{_stringChange.bytesToHexStr(resultBuffer, resultBuffer.Length)}");

                if (resultBuffer[3] == 0xBF || resultBuffer[4] == 0x00)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
        }

        public override async Task<bool> ConnectAsync(string ip, int port, string deviceid)
        {
            try
            {
                m_deviceID = deviceid;
                m_strIP = ip;
                _tcpClient.SetupAsync(new TouchSocketConfig().SetRemoteIPHost($"{ip}:{port}"));
                await _tcpClient.ConnectAsync(1500);
                _tcpClient.Received = (client, e) =>
                {
                    //从客户端收到信息
                    //var mes = Encoding.UTF8.GetString(e.Memory.Span.ToArray(), 0, e.Memory.Span.Length);//注意：数据长度是byteBlock.Len
                   
                    byte[] receivedBuffer = new byte[e.Memory.Span.Length];
                    Array.Copy(e.Memory.Span.ToArray(), 0, receivedBuffer, 0, e.Memory.Span.Length);
                  
                    if (e.Memory.Span.ToArray()[3] == 0x02)
                    {
                        Log.Information($"{m_deviceID},IP:{m_strIP}接收自报{_stringChange.bytesToHexStr(receivedBuffer, receivedBuffer.Length)}");
                        byte[] resultBuffer = PareReceiveBufferData(receivedBuffer, receivedBuffer.Length);
                        List<TagInfo> tagInfoList = Device_DealTagInfoList(resultBuffer);
                        string info = "";
                        if (tagInfoList != null && tagInfoList.Count > 0)
                        {
                            tagInfoList = tagInfoList.Where((x, i) => tagInfoList.FindIndex(z => z.EPCstring == x.EPCstring) == i).ToList();
                            info = string.Join(",", tagInfoList.Select(item => item.EPCstring));
                        }
                        else
                        {
                            info = "Nodata";
                        }
                        _Action?.Invoke(m_deviceID, tagInfoList);
                    }
                    else
                    {
                        Log.Information($"{m_deviceID},IP:{m_strIP}接收原始报文{_stringChange.bytesToHexStr(receivedBuffer, receivedBuffer.Length)}");
                    }

                        //MesParaData mesParaData = new MesParaData()
                        //{
                        //    EQUID = deviceid,
                        //    EPCID = info,
                        //    READSTATUS = info == "NoData" ? "1" : "0",
                        //    READTIME = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss")
                        //};
                        //_meshttpClient.autoread(mesParaData);
                        //ReceivedClientBufferEvent?.Invoke(receivedBuffer);
                        return EasyTask.CompletedTask;
                };
                return true;
            }
            catch (Exception e)
            {
                return false;
            }
        }

        public override bool GetOnlineStatus()
        {
            try
            {
                return _tcpClient.Online;
            }
            catch (Exception e)
            {
                return false;
            }
        }

        public override Task<List<TagInfo>> GetRFIDAsync(int timeout = 1500)
        {
            throw new NotImplementedException();
        }

        public override Task<string> Get_Rf()
        {
            throw new NotImplementedException();
        }

        public override Task<bool> Set_Rf(int iDbi)
        {
            throw new NotImplementedException();
        }

        public override Task<bool> WriteAlarmLight(int port, ushort Timedout)
        {
            throw new NotImplementedException();
        }

        public override async Task<bool> Set_FilterData(string Filter)
        {
            bool iflag = false;
            string pre = "filter ";
            //Filter = "FC 08";
            try
            {
                if (!string.IsNullOrEmpty(Filter))
                {
                    if (Filter != "0")
                    {
                        Filter = pre + Filter.Trim().Replace(" ", "").Length / 2 + " " + Filter;
                    }
                    else
                    {
                        Filter = pre + Filter.Trim();
                    }
                        var waitClient = _tcpClient.CreateWaitingClient(new WaitingOptions()
                        {
                            FilterFunc = response =>
                            {
                                // 检查响应数据是否符合预期
                                if (response.Memory.Length > 0)
                                {
                                    // 可以根据实际情况添加更多的检查逻辑
                                    return true;
                                }
                                return false;
                            }
                        });
                    //Log.Information($"{m_deviceID}发送修改功率指令{_stringChange.bytesToHexStr(pMessagePack.m_pData, pMessagePack.m_pData.Length)}");
                    Filter = Filter + "\r\n";
                    //byte[] reciveBuffer = await waitClient.SendThenReturnAsync(Filter + "\r\n", 2000);
                    using (var responsedData = await waitClient.SendThenResponseAsync(Filter, 2000))
                    {
                        var memory = responsedData.Memory;
                        string result = Encoding.GetEncoding("GBK").GetString(memory.ToArray(), 0, memory.Length);
                        Log.Information($"{m_deviceID}接收设置过滤指令{result}");
                        return true;
                    }
                    //Log.Information($"{m_deviceID}接收修改功率指令{_stringChange.bytesToHexStr(reciveBuffer, reciveBuffer.Length)}");
                }
                return iflag;
            }
            catch (Exception ex)
            {

                return iflag;
            }
        }

        public override async Task<string> Get_FilterData()
        {
            string iflag = "";
            try
            {
                var waitClient = _tcpClient.CreateWaitingClient(new WaitingOptions()
                {
                    FilterFunc = response =>
                    {
                        // 检查响应数据是否符合预期
                        if ( response.Memory.Length > 0)
                        {
                            // 可以根据实际情况添加更多的检查逻辑
                            return true;
                        }
                        return false;
                    }
                });
                //Log.Information($"{m_deviceID}发送修改功率指令{_stringChange.bytesToHexStr(pMessagePack.m_pData, pMessagePack.m_pData.Length)}");

                //byte[] reciveBuffer = await waitClient.SendThenReturnAsync("filter?\r\n", 2000);

                using (var responsedData = await waitClient.SendThenResponseAsync("filter?\r\n",2000))
                {
                    var memory = responsedData.Memory;
                    string result = Encoding.GetEncoding("GBK").GetString(memory.ToArray(), 0, memory.Length);
                    Log.Information($"{m_deviceID}接收设置过滤指令{result}");
                    return result;
                }
                return iflag;
            }
            catch (Exception ex)
            {

                return iflag;
            }
        }

        public override async Task<bool> Set_Frequencyband(string Frequencyband)
        {
            bool iflag = false;
            byte[] bCRC = new byte[3];
            try
            {
                if (string.IsNullOrEmpty(Frequencyband))
                {
                    return iflag;
                }
                Frequencyband = StringChange.GetRegionNumber(Frequencyband);
                MessagePack pMessagePack = new MessagePack();
                pMessagePack.m_pData = new byte[7];
                pMessagePack.m_pData[0] = 0xAA;
                pMessagePack.m_pData[1] = 0x55;
                pMessagePack.m_pData[2] = 0x01;
                pMessagePack.m_pData[3] = 0x44;
                pMessagePack.m_pData[4] = Convert.ToByte(Frequencyband);
                Array.Copy(pMessagePack.m_pData, 2, bCRC, 0, 3);
                pMessagePack.m_pData[5] = _stringChange.CalculateVerify(bCRC, bCRC.Length);
                pMessagePack.m_pData[6] = 0x0D;

                var waitClient = _tcpClient.CreateWaitingClient(new WaitingOptions()
                {
                    FilterFunc = response =>
                    {
                        // 检查响应数据是否符合预期
                        if (response.Memory.Length > 0)
                        {
                            // 可以根据实际情况添加更多的检查逻辑
                            return true;
                        }
                        return false;
                    }
                });
                Log.Information($"{m_deviceID}发送设置频段指令{_stringChange.bytesToHexStr(pMessagePack.m_pData, pMessagePack.m_pData.Length)}");
                using (var responsedData = await waitClient.SendThenResponseAsync(pMessagePack.m_pData, 2000))
                {
                    var reciveBuffer = responsedData.Memory.ToArray();
                    Log.Information($"{m_deviceID}接收设置频段指令{_stringChange.bytesToHexStr(reciveBuffer, reciveBuffer.Length)}");
                    if (reciveBuffer[3] == 0x44)
                    {
                        iflag = true;
                        return iflag;
                    }
                    return iflag;
                }
            }
            catch (Exception ex)
            {

                return iflag;
            }
        }

        public override async Task<string> Get_Frequencyband()
        {
            string Frequencyband = "";
            byte[] u16byte = new byte[2];
            byte[] bCRC = new byte[2];
            try
            {
                #region 指令封装

                MessagePack pMessagePack = new MessagePack();
                pMessagePack.m_pData = new byte[6];
                pMessagePack.m_pData[0] = 0xAA;
                pMessagePack.m_pData[1] = 0x55;
                pMessagePack.m_pData[2] = 0x00;
                pMessagePack.m_pData[3] = 0x74;
                Array.Copy(pMessagePack.m_pData, 2, bCRC, 0, 2);
                pMessagePack.m_pData[4] = _stringChange.CalculateVerify(bCRC, bCRC.Length);
                pMessagePack.m_pData[5] = 0x0D;
                #endregion 指令封装

                var waitClient = _tcpClient.CreateWaitingClient(new WaitingOptions()
                {
                    FilterFunc = response =>
                    {
                        // 检查响应数据是否符合预期
                        if (response.Memory.Length > 0)
                        {
                            // 可以根据实际情况添加更多的检查逻辑
                            return true;
                        }
                        return false;
                    }
                });
                Log.Information($"{m_deviceID}发送获取频段指令{_stringChange.bytesToHexStr(pMessagePack.m_pData, pMessagePack.m_pData.Length)}");
                using (var responsedData = await waitClient.SendThenResponseAsync(pMessagePack.m_pData, 2000))
                {
                    var reciveBuffer = responsedData.Memory.ToArray();
                    Log.Information($"{m_deviceID}接收获取频段指令{_stringChange.bytesToHexStr(reciveBuffer, reciveBuffer.Length)}");
                    if (reciveBuffer[3] == 0x74)
                    {
                        byte bDB = reciveBuffer[5];
                        Frequencyband = StringChange.GetRegionByNumber(bDB.ToString());
                        return Frequencyband;
                    }
                }


                return Frequencyband;
            }
            catch (Exception e)
            {
                return Frequencyband;
                //throw new InvalidOperationException($"{m_strIP}设置功率异常：{e.Message}");
            }
        }
        public override async Task<bool> SendHeartPack()
        {
            bool iflag = false;
            byte[] bCRC = new byte[2];
            try
            {

                MessagePack pMessagePack = new MessagePack();
                pMessagePack.m_pData = new byte[6];
                //获取温度
                pMessagePack.m_pData[0] = 0xAA;
                pMessagePack.m_pData[1] = 0x55;
                pMessagePack.m_pData[2] = 0x00;
                pMessagePack.m_pData[3] = 0x90;
                pMessagePack.m_pData[4] = 0x90;
                pMessagePack.m_pData[5] = 0x0D;

                var waitClient = _tcpClient.CreateWaitingClient(new WaitingOptions()
                {
                    FilterFunc = response =>
                    {
                        // 检查响应数据是否符合预期
                        if (response.Memory.Length > 0)
                        {
                            // 可以根据实际情况添加更多的检查逻辑
                            return true;
                        }
                        return false;
                    }
                });
                _logger.Data($"{m_deviceID},IP:{m_strIP}发送心跳包{_stringChange.bytesToHexStr(pMessagePack.m_pData, pMessagePack.m_pData.Length)}");
                using (var responsedData = await waitClient.SendThenResponseAsync(pMessagePack.m_pData, 2000))
                {
                    var reciveBuffer = responsedData.Memory.ToArray();
                    _logger.Data($"{m_deviceID},IP:{m_strIP}接收心跳包{_stringChange.bytesToHexStr(reciveBuffer, reciveBuffer.Length)}");
                    if (reciveBuffer[3] == 0x90)
                    {
                        iflag = true;
                        return iflag;
                    }
                    return iflag;
                }
            }
            catch (Exception ex)
            {
                _logger.Data($"》》》设备：{m_deviceID},IP:{m_strIP},心跳包发送超时：{ex}");
                return iflag;
            }
        }

        /// <summary>
        /// 状态机函数
        /// </summary>
        /// <param name="buffer"></param>
        /// <param name="iLen"></param>
        /// <returns></returns>
        /// <exception cref="InvalidOperationException"></exception>
        private byte[] PareReceiveBufferData(byte[] buffer, int iLen)
        {
            RecvState enumRecvState = RecvState.WaitingBeginChar1_State;
            int m_iPosition = 0;
            UInt16 m_iFullMessageLength = 0;
            int iBarcodeLength = 0;//条码长度
            ArrayList m_FrecvData = new ArrayList();
            byte m_iVerify = 0;
            try
            {
                var bufferStr = _stringChange.bytesToHexStr(buffer, iLen);
                byte[] m_szFullMessage = new byte[iLen];
                for (int i = 0; i < iLen; i++)
                {
                    switch (enumRecvState)
                    {
                        case RecvState.WaitingBeginChar1_State:         //开始接受数据帧1 0xBB
                            Array.Clear(m_szFullMessage, 0, iLen);//清空为0
                            if (buffer[i] == 0xBB)
                            {
                                m_szFullMessage[m_iPosition] = buffer[i];
                                m_iPosition++;
                                enumRecvState = RecvState.WaitingBeginChar2_State;
                            }
                            else
                            {
                                m_iFullMessageLength = 0;
                                m_iPosition = 0;
                                enumRecvState = RecvState.WaitingBeginChar1_State;
                            }
                            break;
                        case RecvState.WaitingBeginChar2_State:             //开始接受数据帧1 0xDD
                            if (buffer[i] == 0xDD)
                            {
                                m_szFullMessage[m_iPosition] = buffer[i];
                                m_iPosition++;
                                enumRecvState = RecvState.WaitingForBarcodeLength_State;
                            }
                            else
                            {
                                m_iFullMessageLength = 0;
                                m_iPosition = 0;
                                enumRecvState = RecvState.WaitingBeginChar1_State;
                            }
                            break;
                        case RecvState.WaitingForBarcodeLength_State:         //开始接受数据长度(TagCount - EPC)                        
                            m_szFullMessage[m_iPosition] = buffer[i];
                            iBarcodeLength = buffer[i];                      //单组标签：18；两组标签：35
                            m_iPosition++;
                            enumRecvState = RecvState.WaitingForCode_State;
                            break;

                        case RecvState.WaitingForCode_State:                //开始接受指令编号
                            if (buffer[i] == 0x02)
                            {
                                m_szFullMessage[m_iPosition] = buffer[i];
                                m_iPosition++;
                                enumRecvState = RecvState.WaitingForStus_State;
                            }
                            else if (buffer[i] == 0x42)
                            {
                                m_szFullMessage[m_iPosition] = buffer[i];
                                m_iPosition++;
                                enumRecvState = RecvState.WaitingForStus_State;
                            }
                            else if (buffer[i] == 0x72)
                            {
                                m_szFullMessage[m_iPosition] = buffer[i];
                                m_iPosition++;
                                enumRecvState = RecvState.WaitingForStus_State;
                            }
                            else if (buffer[i] == 0x90)          // 如果是心跳BB DD 01 90 00 1F 8E 0D 
                            {
                                m_szFullMessage[m_iPosition] = buffer[i];
                                m_iPosition++;
                                enumRecvState = RecvState.WaitingForEndChar_State;
                            }
                            else if (buffer[i] == 0xBF)          // 如果是心跳BB DD 04 BF 00 00 00 F9 0B 49 0D
                            {
                                m_szFullMessage[m_iPosition] = buffer[i];
                                m_iPosition++;
                                enumRecvState = RecvState.WaitingForEndChar_State;
                            }
                            else
                            {
                                m_iFullMessageLength = 0;
                                m_iPosition = 0;
                                enumRecvState = RecvState.WaitingBeginChar1_State;
                            }
                            break;
                        case RecvState.WaitingForStus_State:        //开始接受状态码
                            if (buffer[i] == 0x00)
                            {
                                m_szFullMessage[m_iPosition] = buffer[i];
                                m_iPosition++;
                                enumRecvState = RecvState.WaitingForTagCount_State;
                            }
                            else if (buffer[i] == 0x40)
                            {
                                m_szFullMessage[m_iPosition] = buffer[i];
                                //LogService.Instance.Debug("RFU620等待接受WaitingForEndChar_State:Noread");
                                lock (m_FrecvData)
                                {
                                    m_FrecvData.Add(m_szFullMessage);
                                }
                                m_iPosition = 0;
                                i = iLen;
                                enumRecvState = RecvState.WaitingBeginChar1_State;
                                //LogService.Instance.Debug("RFly-I160状态机结束。");
                            }
                            break;
                        case RecvState.WaitingForTagCount_State:         //开始接受标签组数                        
                            Array.Copy(buffer, i, m_szFullMessage, m_iPosition, iBarcodeLength);//m_iPosition = 5
                            byte[] tempData = new byte[iBarcodeLength];
                            Array.Clear(tempData, 0, iBarcodeLength);
                            Array.Copy(buffer, i, tempData, 0, iBarcodeLength);
                            m_iPosition = m_iPosition + iBarcodeLength;     //m_iPosition = 39
                            i = i + iBarcodeLength - 1;                         //i = 39
                            enumRecvState = RecvState.WaitingForXor_State;
                            break;
                        case RecvState.WaitingForXor_State:         //开始比对校验位 Rfly160 
                            byte[] m_CRCVerify = new byte[1024];     //此数组用于校验位计算
                            Array.Clear(m_CRCVerify, 0, m_CRCVerify.Length);
                            Array.Copy(m_szFullMessage, 2, m_CRCVerify, 0, iBarcodeLength + 3); //校验位计算是从Length - EPC 结束
                            m_szFullMessage[m_iPosition] = buffer[i];
                            m_iVerify = m_szFullMessage[m_iPosition];
                            if (m_iVerify == _stringChange.CalculateVerify(m_CRCVerify, m_CRCVerify.Length))
                            {
                                m_iPosition++;
                                enumRecvState = RecvState.WaitingForEndChar_State;
                            }
                            else	   //如果校验不成功
                            {
                                m_iFullMessageLength = 0;
                                m_iPosition = 0;
                                enumRecvState = RecvState.WaitingBeginChar1_State;
                            }
                            break;
                        case RecvState.WaitingForEndChar_State:
                            if (buffer[0] == 0xBB && buffer[1] == 0xDD && buffer[2] == 0x00 && buffer[3] != 0x90) //此处为Noread数据显示
                            {
                                m_szFullMessage[0] = 0xBB;
                                m_szFullMessage[1] = 0xDD;
                                m_szFullMessage[2] = 0x00;
                                lock (m_FrecvData)
                                {
                                    m_FrecvData.Add(m_szFullMessage);
                                }
                                m_iPosition = 0;
                                i = iLen;
                                enumRecvState = RecvState.WaitingBeginChar1_State;
                            }
                            else if (buffer[0] == 0xBB && buffer[1] == 0xDD && buffer[2] == 0x04 && buffer[3] == 0xBF)
                            {
                                Array.Copy(buffer, 0, m_szFullMessage, 0, 11);
                                i = 11;
                                lock (m_FrecvData)
                                {
                                    m_FrecvData.Add(m_szFullMessage);
                                }
                                i = iLen;
                            }
                            else if (buffer[i] == 0x00)         //获取温度
                            {
                                Array.Copy(buffer, 0, m_szFullMessage, 0, 8);
                                i = 8;
                                lock (m_FrecvData)
                                {
                                    m_FrecvData.Add(m_szFullMessage);
                                }
                                i = iLen;
                            }
                            else if (buffer[i] == 0x11)
                            {
                                Array.Copy(buffer, 0, m_szFullMessage, 0, 7);
                                i = 7;
                                lock (m_FrecvData)
                                {
                                    m_FrecvData.Add(m_szFullMessage);
                                }
                            }
                            else if (buffer[i] == 0x01)
                            {
                                Array.Copy(buffer, 0, m_szFullMessage, 0, 8);
                                i = 8;
                                lock (m_FrecvData)
                                {
                                    m_FrecvData.Add(m_szFullMessage);
                                }
                            }
                            else
                            {
                                m_szFullMessage[m_iPosition] = buffer[i];
                                m_iPosition++;
                                if (buffer[i] == 0x0D)
                                {
                                    lock (m_FrecvData)
                                    {
                                        m_FrecvData.Add(m_szFullMessage);
                                    }
                                }
                            }
                            m_iPosition = 0;
                            enumRecvState = RecvState.WaitingBeginChar1_State;
                            break;
                    }
                }

                return m_szFullMessage;
            }
            catch (Exception e)
            {
                throw new InvalidOperationException($"状态机逻辑处理异常：{e.Message}");
            }
        }

        //private Mutex mutauto = new Mutex();
        /// <summary>
        /// 解析函数
        /// </summary>
        /// <param name="AutoDealReportData"></param>
        /// <returns></returns>
        /// <exception cref="InvalidOperationException"></exception>
        public List<TagInfo> Device_DealTagInfoList(byte[] AutoDealReportData)
        {
            List<TagInfo> tagInfoList = new List<TagInfo>();
            byte[] bResultEPC_Data = new byte[14];
            byte[] m_AutoReadEPC = null;
            int m_readEPCDataLen = 0;
            try
            {
                //mutauto.WaitOne();
                int iFirstCountPos = 6;     //第一次读取标签次数位置
                int iFirstRSSIPos = 7;      //第一次读取标签强度位置
                int iFirstAnt = 8;
                int iFirstPC = 9;   //第一次读取标签天线位置
                int iFirstLeftBarcketPos = 11;//EPC数据起始位置
                UInt16 tempDataCount = 0;
                int tempDataRSSI = 0;
                UInt16 tempDataANT = 0;
                int iBarcodeGroupCount = Convert.ToInt32(AutoDealReportData[5].ToString()); //标签组数
                int iBarcodeLength = 12;        //标签长度
                int iCommonSecondFlag = 0;
                for (int j = 0; j < iBarcodeGroupCount; j++)
                {
                    TagInfo tag = new TagInfo();
                    byte[] tempPCByte = new byte[2];     //取出PC
                    Array.Clear(tempPCByte, 0, 2);
                    Array.Copy(AutoDealReportData, iFirstPC, tempPCByte, 0, 2);

                    //int pc = Convert.ToInt32(tempPCByte[0].ToString("X"));
                    //PC转二进制取前五位转十进制
                    int epcLength = Convert.ToInt32(Convert.ToString(Convert.ToInt64(tempPCByte[0].ToString("X"), 16), 2).PadLeft(8, '0').Substring(0, 5), 2) * 2;

                    //int epcLength = EPCLengthByPC(pc);
                    iBarcodeLength = epcLength;

                    byte[] tempDataByte = new byte[epcLength];
                    Array.Clear(tempDataByte, 0, iBarcodeLength);
                    Array.Copy(AutoDealReportData, iFirstLeftBarcketPos, tempDataByte, 0, iBarcodeLength);

                    byte[] tempCountByte = new byte[1];     //取出标签次数
                    Array.Clear(tempCountByte, 0, 1);
                    Array.Copy(AutoDealReportData, iFirstCountPos, tempCountByte, 0, 1);
                    tempDataCount = tempCountByte[0];

                    byte[] tempRSSIByte = new byte[1];     //取出标签强度
                    Array.Clear(tempRSSIByte, 0, 1);
                    Array.Copy(AutoDealReportData, iFirstRSSIPos, tempRSSIByte, 0, 1);

                    tempDataRSSI = _stringChange.HexStringToNegative(_stringChange.bytesToHexStr(tempRSSIByte, 1));

                    #region add by wenjy 20220829 取出天线号
                    byte[] tempAntByte = new byte[1];     //取出天线号
                    Array.Clear(tempAntByte, 0, 1);
                    Array.Copy(AutoDealReportData, iFirstAnt, tempAntByte, 0, 1);
                    tempDataANT = tempAntByte[0];
                    #endregion

                    tag.Count = tempDataCount;
                    tag.RSSI = tempDataRSSI;
                    tag.EPC = tempDataByte;
                    //tag.EPCstring = _stringChange.bytesToHexStr(tempDataByte, tempDataByte.Length).Substring(0, 8);
                    tag.EPCstring = _stringChange.bytesToHexStr(tempDataByte, tempDataByte.Length);
                    tag.PC = tempPCByte;
                    tag.Antana = tempDataANT;
                    tagInfoList.Add(tag);
                    int iBarcodeListLen = tagInfoList.Count; //特别注意，必须这样，要不然会多一条数据

                    iFirstCountPos = iFirstCountPos + iBarcodeLength + 5; //次数
                    iFirstRSSIPos = iFirstCountPos + 1; //强度
                    iFirstAnt = iFirstRSSIPos + 1; //天线
                    iFirstPC = iFirstAnt + 1;
                    iFirstLeftBarcketPos = iFirstLeftBarcketPos + iBarcodeLength + 5;
                    _RefreshLogMessageAction?.Invoke($"----{m_deviceID}第[" + (iCommonSecondFlag + 1) + "]次数据解析为：" + tag.EPCstring + ",\r\n读取标签次数：[" + tempDataCount + "],标签信号强度：[" + tempDataRSSI + "],天线号：[" + tempDataANT + "]");
                    Log.Information($"----{m_deviceID}第[" + (iCommonSecondFlag + 1) + "]次数据解析为：" + tag.EPCstring + ",读取标签次数：[" + tempDataCount + "],标签信号强度：[" + tempDataRSSI + "],天线号：[" + tempDataANT + "]");
                    iCommonSecondFlag++;
                    if (iCommonSecondFlag == iBarcodeGroupCount)
                    {
                        TagInfo bestTag = tagInfoList
                            .OrderByDescending(t => t.Count)  // 第一条件：Count从大到小
                            .ThenByDescending(t => t.RSSI)   // 第二条件：RSSI从大到小
                            .FirstOrDefault();
                        List<TagInfo> bestTagList = new List<TagInfo>();
                        bestTagList.Add(bestTag);
                        //mutauto.ReleaseMutex();
                        //_logger.LogInformation("《《《返回标签数据！");
                        return bestTagList;
                    }
                }
                return tagInfoList;
            }
            catch (Exception ex)
            {
                //mutauto.ReleaseMutex();
                throw new InvalidOperationException($"Device_AutoDealContent 自动处理函数异常:{ex.Message}");
            }
        }

        public override Task<bool> Set_BeginIdentify()
        {
            throw new NotImplementedException();
        }

        public override Task<bool> Set_Write(byte[] pSelectData, string pWriteData)
        {
            throw new NotImplementedException();
        }

        public override Task<bool> Set_StopIdentify()
        {
            throw new NotImplementedException();
        }
    }
}
